#!/usr/bin/env python3

"""
Cuchulufm is a series of wrappers for bottle, mako and others and construct a simple headless cms.

Copyright (C) 2023 Antonio de la Rosa Caballero

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""

from cuchulu.libraries.db.corefields import CharField
from cuchulu.libraries.db import coreforms
from cuchulu.libraries.i18n import I18n

class LangField(CharField):
    """Field for save language codes, by default es-ES (spanish) and en-US (USA english)"""
    
    def __init__(self, name, size=255, required=False):
    
        super(CharField, self).__init__(name, size, required)
        
        select_lang={}

        for lang in I18n.dict_i18n:
            select_lang[lang]=lang

        self.change_form(coreforms.SelectForm, [select_lang])
        self.default_value=I18n.default_lang
        
    def check(self, value):
        
        if value not in I18n.dict_i18n:
            
            value=I18n.default_lang

        return value
